HDU4385Moving Bricks【状压DP】

Moving Bricks

Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 724    Accepted Submission(s): 280


Problem Description
Brickgao used to be a real tall, wealthy, handsome man and you might know him well. If you don't, please draw attention to the details below.
Brickgao tried his fortune in investment of golden bricks with his two partners LS and Jne. Because he knew little about investment he gave his total trust and bank savings to his two partners who looked smart. 
However, due to the bad luck and lack of business skills, LS and Jne used up Brickgao's fund, and nothing in return. Their investment failed and the three become diaosi. 
Brickgao had no other choice but to earn a living as a construction worker and he found his place on a building site moving bricks which of course was not golden ones. There were many brick fragment scattered on the site and workers had to move them to the building that under construction. Brickgao was made to cope with the task.
The problem is that the Brickgao couldn’t carry more than two bricks at a time since they were too heavy. Also, if he had taken a brick, he couldn’t put it anywhere except the goal building — his inherent sense of order does not let him do so.
You are given N pairs of coordinates of the bricks and the coordinates of the goal building. It is known that the Brickgao covers the distance between any two points in the time equal to the squared length of the segment between the points. It is also known that initially the coordinates of the Brickgao and the goal building are the same. You are asked to find such an order of bricks, that the Brickgao could move all the bricks to the building in a minimum time period. You can assume the no two bricks shared the same coordinates. If more than one optimum moving sequence Brickgao could find, he would choose the smallest lexicographic one because of the inherent sense of order.
 

 

Input
The first line of the input file contains an integer T which indicates the number of test cases. The first line of each case contains the building's coordinates x ,y. The second line contains number N (1<= N < 20) — the amount of bricks on the building site. The following N lines contain the bricks' coordinates. All the coordinates do not exceed 100 in absolute value. All the given positions are different. All the numbers are integer.
 

 

Output
For each test case, first you should print "Case x:" in a line, where x stands for the case number started with 1. Then two lines follow: the first line output the only number — the minimum time Brickgao needed to move the bricks to building, and the second line output the optimum order for Brickgao to move the bricks. Each brick in the input is described by its index number (from 1 to N).
 

 

Sample Input
2 0 0 2 1 1 -1 1 1 1 3 4 3 3 4 0 0
 

 

Sample Output
Case 1: 8 1 2 Case 2: 32 1 2 3
Hint
In the first test, Brickgao gets brick 1 and brick 2 and returns to the building. In the second test, Brickgao first moves brick 1 and brick 2 to the building and then gets the third and returns to the building.
 

 

Author
WHU
 

 

Source

 

这个题说实话也卡了很多天了  原因是 字典序最小之前没有处理好

 

之前做过一个很像的题  是一次训练赛德题  

那题是这样的  告诉你n个点n 《= 15  的坐标  问一笔画下来最少的路程

那个是这样的dp[i][j]代表状态为i  以第j个点位结尾的最短路

由于|的性质  所以直接往后枚举状态进行转移就可以了

 

这个题很像  

题意是有n个点n<20  每次从初始点出发取回一个或两个点上的石头   取回需要的价值是 距离的平方和

然后问取回所有点的最小价值

这个题dp[i]代表到大i状态的最短路  然后用一个数组表示最短路的最后一个点是啥 

最后 由于每次只取回一或者两个点  只要把它拍一下序就好了

代码:

  1 #include <iostream>
  2 #include <cstdio>
  3 #include <cstring>
  4 #include <algorithm>
  5 using namespace std;
  6 
  7 const int maxn = 20;
  8 int dp[1 << maxn];
  9 int x[maxn], y[maxn];
 10 int dist[maxn][maxn];
 11 int n, t;
 12 int fa[maxn];
 13 
 14 struct Node {
 15     int pr;
 16     int x1, x2;
 17 }node[1 << maxn];
 18 struct Ans {
 19     int flag;
 20     int x1, x2;
 21 }ans[maxn];
 22 bool cmp(Ans a1, Ans a2) {
 23     return a1.x1 < a2.x1;
 24 }
 25 int xx[1 << maxn];
 26 int an[maxn];
 27 
 28 void init() {
 29     for(int i = 0; i <= n; i++) {
 30         for(int j = i; j <= n; j++) {
 31             dist[i][j] = dist[j][i] = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j])*(y[i] - y[j]);
 32             dist[j][i] = dist[i][j];
 33         }
 34     }
 35 }
 36 
 37 void DP() {
 38     memset(dp, 0x3f, sizeof(dp));
 39     dp[0] = 0; xx[0] = 0;
 40     fa[0] = 0;
 41     int Max = 1 << n;
 42     for(int i = 0; i < Max; i++) {
 43         if(dp[i] > 1000000000) continue;
 44         for(int j = 1; j <= n; j++) {
 45             if((i & ( 1 << ( j - 1 ) ) ) == 0 ) {
 46                 int num = i | ( 1 << ( j - 1 ) );
 47                 if(dp[num] > dp[i] + dist[j][0] * 2) {
 48                     dp[num] = dp[i] + dist[j][0] * 2;
 49                     xx[num] = j;
 50                     node[num] = (Node) { i, 0, 0 };
 51                 }
 52             }
 53         }
 54         for(int j = 1; j <= n; j++) {
 55             for(int k = j + 1; k <= n; k++) {
 56                 if((i & ( 1 << ( j - 1 ) ) ) == 0 && ( i & ( 1 << ( k - 1) ) ) == 0) {
 57                     int num = i | ( 1 << ( j - 1 ) );
 58                     num |= ( 1 << ( k - 1) );
 59                     if(dp[num] > dp[i] + dist[0][j] + dist[j][k] + dist[k][0]) {
 60                         dp[num] = dp[i] + dist[0][j] + dist[j][k] + dist[k][0];
 61                         xx[num] = j;
 62                         node[num] = (Node) { i, 1, k };
 63                     }
 64                 }
 65             }
 66         }
 67     }
 68 }
 69 
 70 void P() {
 71     int Max = 1 << n;
 72     printf("%d\n", dp[Max - 1]);
 73     int id = Max - 1;
 74     int cnt = 0;
 75     for(int i = 1; i <= n; i++) {
 76         if(node[id].x1 == 0) {
 77             ans[cnt++] = (Ans) { 1, xx[id], 0 };
 78         } else {
 79             ans[cnt++] = (Ans) { 2, min(xx[id],node[id].x2), max(xx[id],node[id].x2)};
 80             i++; 
 81         }
 82         id = node[id].pr;
 83     }
 84     sort(ans, ans + cnt, cmp);
 85     int cn = 0;
 86     for(int i = 0; i < cnt; i++) {
 87         if(ans[i].flag == 1) {
 88             an[cn++] = ans[i].x1;
 89         } else {
 90             an[cn++] = ans[i].x1;
 91             an[cn++] = ans[i].x2;
 92         }
 93     }
 94     for(int i = 0; i < cn; i++) {
 95         printf(i == 0 ? "%d" : " %d", an[i]);
 96     } puts("");
 97 }
 98 
 99 int main() {
100     scanf("%d",&t);
101     for(int kase = 1; kase <= t; kase++) {
102         scanf("%d %d",&x[0], &y[0]);
103         scanf("%d",&n);
104         for(int i = 1; i <= n; i++) {
105             scanf("%d %d",&x[i], &y[i]);
106         }
107         init();
108         DP();
109         printf("Case %d:\n", kase);
110         P();
111     }
112     return 0;
113 }
View Code

 

转载于:https://www.cnblogs.com/zhanzhao/p/4156421.html

### 回答1: hdu 2829 Lawrence 斜率优化dp 这道题是一道经典的斜率优化dp题目,需要用到单调队列的思想。 题目大意是给定一个序列a,求出一个序列b,使得b[i]表示a[1]~a[i]中的最小值,且满足b[i] = min{b[j] + (i-j)*k},其中k为给定的常数。 我们可以将上式拆开,得到b[i] = min{b[j] - j*k} + i*k,即b[i] = i*k + min{b[j] - j*k},这个式子就是斜率优化dp的形式。 我们可以用单调队列来维护min{b[j] - j*k},具体思路如下: 1. 首先将第一个元素加入队列中。 2. 从第二个元素开始,我们需要将当前元素加入队列中,并且需要维护队列的单调性。 3. 维护单调性的方法是,我们从队列的末尾开始,将队列中所有大于当前元素的元素弹出,直到队列为空或者队列中最后一个元素小于当前元素为止。 4. 弹出元素的同时,我们需要计算它们对应的斜率,即(b[j]-j*k)/(j-i),并将这些斜率与当前元素的斜率比较,如果当前元素的斜率更小,则将当前元素加入队列中。 5. 最后队列中的第一个元素就是min{b[j] - j*k},我们将它加上i*k就得到了b[i]的值。 6. 重复以上步骤直到处理完所有元素。 具体实现可以参考下面的代码: ### 回答2: HDU 2829 Lawrence 斜率优化 DP 是一道经典的斜率优化 DP 题目,其思想是通过维护一个下凸包来优化 DP 算法。下面我们来具体分析一下这道题目。 首先,让我们看一下该题目的描述。题目给定一些木棒,要求我们将这些木棒割成一些给定长度,且要求每种长度的木棒的数量都是一样的,求最小的割枝次数。这是一个典型的背包问题,而且在此基础上还要求每种长度的木棒的数量相同,这就需要我们在状态设计上走一些弯路。 我们来看一下状态的定义。定义 $dp[i][j]$ 表示前 $i$ 个木棒中正好能割出 $j$ 根长度为 $c_i$ 的木棒的最小割枝次数。对于每个 $dp[i][j]$,我们可以分类讨论: 1. 不选当前的木棒,即 $dp[i][j]=dp[i-1][j]$; 2. 选当前的木棒,即 $dp[i][j-k]=dp[i-1][j-k]+k$,其中 $k$ 是 $j/c_i$ 的整数部分。 现在问题再次转化为我们需要在满足等量限制的情况下,求最小的割枝次数。可以看出,这是一个依赖于 $c_i$ 的限制。于是,我们可以通过斜率优化 DP 来解决这个问题。 我们来具体分析一下斜率优化 DP 算法的思路。我们首先来看一下动态规划的状态转移方程 $dp[i][j]=\min\{dp[i-1][k]+x_k(i,j)\}$。可以发现,$dp[i][j]$ 的最小值只与 $dp[i-1][k]$ 和 $x_k(i,j)$ 有关。其中,$x_k(i,j)$ 表示斜率,其值为 $dp[i-1][k]-k\times c_i+j\times c_i$。 接下来,我们需要维护一个下凸包,并通过斜率进行优化。我们具体分析一下该过程。假设我们当前要计算 $dp[i][j]$。首先,我们需要找到当前点 $(i,j)$ 在凸包上的位置,即斜率最小值的位置。然后,我们根据该位置的斜率计算 $dp[i][j]$ 的值。接下来,我们需要将当前点 $(i,j)$ 加入到下凸包上。 我们在加入点的时候需要注意几点。首先,我们需要将凸包中所有斜率比当前点小的点移除,直到该点能够加入到凸包中为止。其次,我们需要判断该点是否能够加入到凸包中。如果不能加入到凸包中,则直接舍弃。最后,我们需要保证凸包中斜率是单调递增的,这就需要在加入新的点之后进行上一步操作。 以上就是该题目的解题思路。需要注意的是,斜率优化 DP 算法并不是万能的,其使用情况需要根据具体的问题情况来确定。同时,该算法中需要维护一个下凸包,可能会增加一些算法的复杂度,建议和常规 DP 算法进行对比,选择最优的算法进行解题。 ### 回答3: 斜率优化DP是一种动态规划优化算法,其主要思路是通过对状态转移方程进行变形,提高算法的时间复杂度。HDU2829 Lawrence问题可以用斜率优化DP解决。 首先,我们需要了解原问题的含义。问题描述如下:有$n$个人在数轴上,第$i$个人的位置为$A_i$,每个人可以携带一定大小的行李,第$i$个人的行李重量为$B_i$,但是每个人只能帮助没有他们重量大的人搬行李。若第$i$个人搬运了第$j$个人的行李,那么第$i$个人会累加$C_{i,j}=\left|A_i-A_j\right|\cdot B_j$的体力消耗。求$m$个人帮助每个人搬运行李的最小体力消耗。 我们可以通过斜率优化DP解决这个问题。记$f_i$为到前$i$个人的最小体力消耗,那么状态转移方程为: $$f_i=\min_{j<i}\{f_j+abs(A_i-A_j)\cdot B_i\}$$ 如果直接使用该方程,时间复杂度为$O(n^2)$,如果$n=10^4$,则需要计算$10^8$次,运算时间极长。斜率优化DP通过一些数学推导将方程变形,将时间复杂度降低到$O(n)$,大大缩短了计算时间。 通过斜率优化DP的推导式子,我们可以得到转移方程为: $$f_i=\min_{j<i}\{f_j+slope(j,i)\}$$ 其中,$slope(j,i)$表示直线$j-i$的斜率。我们可以通过如下方式来求解$slope(j,i)$: $$slope(j,i)=\frac{f_i-f_j}{A_i-A_j}-B_i-B_j$$ 如果$slope(j,i)\leq slope(j,k)$,那么$j$一定不是最优,可以直接舍去,降低计算时间。该算法的时间复杂度为$O(n)$。 综上所述,斜率优化DP是一种动态规划优化算法,可以大大缩短计算时间。在处理类似HDU2829 Lawrence问题的时候,斜率优化DP可以很好地解决问题。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值